; DoSync v0.1 by Mark Jones 2006 (gzscuqn02 AT sneakemail D0T com)
; Use with SyncDir3 to autonomously backup files to a removable drive
; DoSync waits for the removable drive to come online, then shells SyncDir
; using a custom .ini file. Refer to readme.txt for more info.

include masm32rt.inc                    ; standard compile-time libs

.const
    szMutex         db  "Global\DoSyncv0.1",0,0,0   ; instance marker
    szDoSync        db  "DoSync v0.1",0         ; dialog text
    szPowerUpDrive  db  "Please connect drive...",0
    szOpen          db  "open",0,0,0,0          ; file_open
    szProg          db  "SyncDir3.exe",0,0,0,0  ; file to run
    szArgs          db  "DoSync.ini",0,0        ; copy parameters
.data?
    hFolder         dd  ?               ; handle to drive
    hMutex          dd  ?               ; handle to instance
    szTemp          db 128 dup(?)       ; command argument buffer
    nCount          db  ?               ; byte used to retry drive 16 times
.data
    szDest          db  "X:\",0         ; removable drive default

.code
start:
    invoke CreateMutex,0,1,addr szMutex ; only allow one instance
    mov hMutex,eax
    .if eax != NULL && FUNC( GetLastError ) == ERROR_ALREADY_EXISTS
        invoke Beep,100,1000            ; error sound
        invoke ExitProcess,0            ; exit!
    .endif

    invoke ArgCl,1,addr szTemp          ; get first command-line argument
    cmp byte ptr [szTemp],00            ; if no value was returned,
    jz retry                            ; use default dest, else
    mov al,byte ptr [szTemp]            ; fetch letter
    mov byte ptr [szDest],al            ; put it in szDest

retry:
    invoke CreateFile,addr szDest,\     ; try opening destination folder
                      FILE_LIST_DIRECTORY,\
                      FILE_SHARE_READ+FILE_SHARE_WRITE+FILE_SHARE_DELETE,\
                      NULL,\
                      OPEN_EXISTING,\
                      FILE_FLAG_BACKUP_SEMANTICS,\
                      NULL
    mov hFolder,eax                     ; save "folder" handle
    .if FUNC(GetLastError) == ERROR_PATH_NOT_FOUND
        invoke CloseHandle,hFolder      ; close file handle
        invoke Sleep,1000               ; wait 1 second
        sub nCount,16                   ; decrease counter by 16
        jnz retry                       ; repeat 16 times
        invoke MessageBox,0,addr szPowerUpDrive,addr szDoSync,\
                          MB_RETRYCANCEL+MB_SYSTEMMODAL
        .if eax==IDCANCEL
            jmp endit                   ; exit
        .else
            jmp retry                   ; try again
        .endif
    .else
        invoke Beep,400,100             ; easily-recognized audible signal
        invoke ShellExecute,0,addr szOpen,addr szProg,addr szArgs,0,SW_SHOW
        invoke Beep,200,100             ; indicating start and finish
    .endif
endit:
    invoke CloseHandle,hFolder          ; close file handle
    invoke CloseHandle,hMutex           ; close mutex handle
    invoke ExitProcess,0                ; exit gracefully
end start
